# encoding: utf-8
class Antiquity

  def initialize(periods)
    @periods = periods.sort { |a,b| a.start_date <=> b.start_date }
  end

  def days(upto_date=Date.today)
    @periods.inject(0) { |total, period| total + period.days(upto_date) }
  end

  def months(upto_date=Date.today)
    @periods.inject(0) { |total, period| total + period.months(upto_date) }
  end

  def years(upto_date=Date.today)
    months(upto_date).divmod(12).first
  end

  def to_s(upto_date=Date.today)
    date = (@periods.last && @periods.last.end_date) || upto_date
    result = ""
    return result if @periods.empty?
    if date >= @periods.first.start_date
      years_upto_date = years(date)
      months_upto_date = months(date)
      result += years_upto_date > 1 ? "#{years_upto_date} años" : "#{years_upto_date} año" unless years_upto_date == 0
      result += ", " if years_upto_date >= 1 && !(months_upto_date.modulo(12).eql?(0))
      result += months_upto_date.modulo(12) > 1 ? "#{months_upto_date.modulo(12)} meses" : "#{months_upto_date.modulo(12)} mes" unless months_upto_date.modulo(12) == 0
      result += "#{(date - @periods.last.start_date).to_i} dias" if months_upto_date.modulo(12) == 0 && years_upto_date == 0 && date > @periods.last.start_date
      result += "Hoy!" if months_upto_date.modulo(12) == 0 && date == @periods.last.start_date
    end
    result += "En unos días..." if date < @periods.first.start_date
    result
  end
end