# encoding: utf-8
class Mail

  def initialize(args)
    @receivers = args[:to]
    @sender = args[:from]
  end

  def template
    raise Exception, "You have to override 'template' method in #{self.class}"
  end

  def subject
    raise Exception, "You have to override 'subject' method in #{self.class}"
  end

  def values
    raise Exception, "You have to override 'values' method in #{self.class}"
  end

  def to
    _receivers = {}
    @receivers.each { |user| _receivers[user.full_name] = "Persons" }
    _receivers
  end

  def from 
    @sender ||= "apps@hexacta.com"
  end

  def send
    MailSender.perform_async(self)
  end

end