# encoding: utf-8
require 'singleton'

class NotificationSender
  include Singleton

  def send_to(user,creator,title,message,label,link=nil)
    notification = Notification.find_or_create(:user_id => user.id,
                                :creator_id => creator.id,
                                :title => title,
                                :message => message,
                                :label => label,
                                :link => link,
                                :creation_date => Date.today)
    if link.nil?
      notification.link = "/notifications/#{notification.id}"
      notification.save
    end
    notification
  end

  def send_to_subscriptors(creator,title,message,label,link=nil)
    Subscription.where(:label => label).all.each do |subscription|
      notification = send_to(subscription.user,creator,title,message,label,link)
    end
  end

  def send_error(creator,title,message)
    Subscription.where(:label => 'error').all.each do |subscription|
      creator = subscription.user if creator.nil?
      notification = Notification.find(:user_id => subscription.user_id,
                                       :creator_id => creator.id,
                                       :title => title,
                                       :message => message,
                                       :label => 'error',
                                       :read_date => nil)
      if notification.nil?
        notification = send_to(subscription.user,creator,title,message,'error')
      end
    end

  end

end
