# encoding: utf-8

class AsyncProcess
  include SuckerPunch::Job
  attr_reader :handler
  attr_reader :user_id
end

class ExampleProcess < AsyncProcess

  attr_reader :log, :error, :interrupted, :name, :id
  
  def self.name
    "THE NAME"
  end

  def perform(handler, other_params)
    @handler = handler
    @handler.total = params[:ids].count
    # loop
    # if error @handler.log("error no falta", e.message)
    # @handler.increase
    #
  end
end

class ProcessHandler

  attr_reader :log, :error, :interrupted, :name, :id, :performed, :total, :clazz, :user_id
  attr_accessor :total

  def initialize(id, name, clazz, user_id)
    @id = id
    @total = 0
    @performed = 0
    @log = []
    @error = ""
    @interrupted = false
    @name = name
    @clazz = clazz
    @user_id = user_id
  end

  def progress
    return 0 if @total == 0
    (@performed.to_f / @total.to_f)*100.0
  end

  def increase
    @performed += 1
  end

  def log(severity, message)
    @log << "[#{severity}] #{Time.now} #{message}"
  end

  def interrupt
    @interrupted = true
  end

  def interrupted?
    @interrupted
  end

  def running?
    @total != @performed
  end
end

class ProcessManager
  include Singleton

  attr_reader :handlers

  def initialize
    @handlers = []
  end

  def find(clazz,user_id)
    @handlers.find { |handler| handler.clazz == clazz && handler.user_id == user_id }
  end

  def run(*args)
    user_id = args[1][:user_id]
    clean(args.first.to_s,user_id)
    if !running?(args.first.to_s,user_id)
      handler = ProcessHandler.new(rand(1..100000000), args.first.name, args.first.to_s, user_id)
      clazz = args.first
      args[0] = handler
      clazz.perform_async(*args)
      @handlers << handler
      handler
    else
      find(args.first.to_s,user_id)
    end
  end

  def finish(handler)
    @handlers -= [handler]
  end

  def clean(clazz,user_id)
    @handlers.select { |handler| handler.clazz == clazz && handler.user_id == user_id }.each do |handler|
      handler.interrupt
      self.finish(handler)
    end
  end

  def running?(clazz,user_id)
    !@handlers.select { |handler| handler.clazz == clazz && handler.user_id == user_id }.empty?
  end

end