# encoding: utf-8
module Sinatra
  module UserConfigurationHandler
    extend Hexacta

    def enable_user_configuration
      p "Enabling user configurations..."

      get '/user/configuration' do
        user = authenticated(User)
        slim :'users/configuration', locals: { :user => user }
      end

      post '/user/configuration' do
        user_configuration_params = params.select { |attribute| UserConfiguration.columns.include?(attribute.to_sym) }
        user_configuration = UserConfiguration.find_or_create(:user_id => authenticated(User).id)
        user_configuration.update_fields(user_configuration_params, UserConfiguration.columns, :missing => :skip)
        redirect back
      end

    end

  end
  register UserConfigurationHandler
end

