# encoding: utf-8
require 'sinatra/base'
require 'sinatra/cross_origin'
require 'fileutils'
require 'sucker_punch'
require 'rufus-scheduler'
require 'similar_text'

module Sinatra

  module Hexacta
    GEM_FILE_DIR = "sinatra-hexacta"

    def gem_path
      File.expand_path("../..",__dir__)
    end

    def copy_file(original_path, link_path)
      IO.copy_stream("#{gem_path}#{original_path}",link_path) unless File.exist?(link_path) && FileUtils.compare_file("#{gem_path}#{original_path}",link_path)
    end

    def copy_all_files(original_path, link_path)
      Dir.foreach("#{gem_path}#{original_path}") do |child|
        copy_file("#{original_path}/#{child}","#{link_path}/#{child}") unless child == '.' || child == '..'
      end
    end

    def setup_dir(path)
      FileUtils.mkdir_p path
    end

    def copy_dir_structure(original_path, destination_path)
      FileUtils.copy_entry("#{gem_path}#{original_path}", destination_path)
    end
  end
end

require_relative 'helpers/init'
require_relative 'handlers/init'
require_relative 'extensions/init'
